﻿//version: 1.0
//unsafe
using System;
using System.Collections;
using System.Text;
using System.Drawing;
using System.Drawing.Text;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Windows.Forms;
using System.Reflection;
using System.Runtime.InteropServices;
using System.IO;

namespace GFBDesktop
{
	public class GFBDesktop:IDisposable
	{
		private System.Windows.Forms.Button GFB; //The "real" object.
		public event EventHandler Click; //The event handler name must match the event name.
		private object[] eventObject; //One object[] for each event (one event here).
		public static object B4P_AutoScale = null;
		public Color StartColor;
		public Color EndColor;
		public int FillDirection;
		    
		
		public GFBDesktop(Control Parent,string Text,int Left, int Top, int Width , int Height, Color Fontcolor,int Fontsize, Color StartColor, Color EndColor, int FillDirection)
		{
			GFB = new System.Windows.Forms.Button() ;
			GFB.Left = Left;
			GFB.Top = Top;
			GFB.Width = Width;
			GFB.Height = Height;
			GFB.ForeColor = Fontcolor;
			GFB.BackColor = Color.Transparent;
			GFB.Text = Text;
						
			this.StartColor = StartColor;
			this.EndColor = EndColor;
			this.FillDirection = FillDirection;
			GFB.Font = new Font(GFB.Font.Name, Fontsize, GFB.Font.Style);
			Parent.Controls.Add(GFB);
			eventObject = new object[] {this,"Click"}; //This is the object that will pass with the event.
			GFB.Click += new System.EventHandler(this.GFB_Click);
			drawbutton(GFB.Width,GFB.Height);
		}
		
		private void drawbutton( int w,int h)
		{
		 //   Bitmap bm = new System.Drawing.Bitmap(w,h);
		 	GFB.Image = new System.Drawing.Bitmap(w,h);
			Rectangle nrc = new System.Drawing.Rectangle(0,0,w,h);
		    LinearGradientBrush gbrush = new LinearGradientBrush(nrc, StartColor, EndColor, (Single)(FillDirection == 0 ? 0 : 90));
        //    Graphics g = Graphics.FromImage(bm);
        	Graphics g = Graphics.FromImage(GFB.Image);
        	//Graphics gr = GFB.CreateGraphics();
        	g.FillRectangle(gbrush, nrc);
        //	gr.DrawImage(bm,nrc);
            g.Dispose();
        //    gr.Dispose();
		}
		
		public double DLLVersion
		{
			get {return 1;}
		}
		
		public System.Windows.Forms.Button Control
		{
			get {return GFB;}
			set {GFB = value;}
		}
		
		public string Text
		{
			get {return GFB.Text;}
			set {GFB.Text = value;}
		}
		
		public float FontSize
        {
            get { return GFB.Font.Size; }
            set { GFB.Font = new Font(GFB.Font.Name, value, GFB.Font.Style); }
        }
		
		public void SetFontStyle ( bool Bold,bool UnderLine, 
			bool Italic, bool StrikeOut)
		{
			FontStyle fntStyle = FontStyle.Regular;
			if (Bold)
				fntStyle |= FontStyle.Bold;
			if (UnderLine)
				fntStyle |= FontStyle.Underline;
			if (Italic)
				fntStyle |= FontStyle.Italic;
			if (StrikeOut)
				fntStyle |= FontStyle.Strikeout;
			GFB.Font = new Font(GFB.Font.Name,GFB.Font.Size,fntStyle);
		}
		
		public int Height
		{
			get {return GFB.Height;}
			set 
			{
				GFB.Height = value;
				drawbutton(GFB.Width,GFB.Height);
			}
		}
		public int Width
		{
			get {return GFB.Width;}
			set 
			{
				GFB.Width = value;
				drawbutton(GFB.Width,GFB.Height);
			}
		}
		public int Left
		{
			get {return GFB.Left;}
			set {GFB.Left = value;}
		}
		public int Top
		{
			get {return GFB.Top;}
			set {GFB.Top = value;}
		}
		
		public Color BackColor
		{
			get {return GFB.BackColor;}
			set {GFB.BackColor = value;}
		} 

		public Color ForeColor
		{
			get {return GFB.ForeColor;}
			set {GFB.ForeColor = value;}
		}
				
		 public void BringToFront()
        {
		 	GFB.BringToFront();
        }
		 public void SendToBack()
        {
		 	GFB.SendToBack();
        }
		
		public bool Enabled
		{
			get {return GFB.Enabled;}
			set {GFB.Enabled = value;}
		}
		public bool Visible
		{
			get {return GFB.Visible;}
			set {GFB.Visible = value;}
		}	
		
		 public void Refresh()
        {
            GFB.Refresh();
        }
		
		private void GFB_Click(Object sender, EventArgs e) 
		{	
			if (Click != null)
			Click(eventObject,null);
			drawbutton(GFB.Width,GFB.Height);
		}
		
		public void Dispose()
		{
			Click = null;
			if (GFB != null)
				GFB.Dispose();
		}
				
	}

}
